//#include <io.h> // For IntelC: Kazuya.c(1): catastrophic error: could not open source file "io.h"
#include <stdio.h>
#include <stdlib.h>

#include "quicklz.h"

// Kaze [
const int GRFFTH_DE_buffer_MAXSIZE = 32 * 12 * 1024 * 1024; // 384MB
int Kazuya_DE_buffer_MAXSIZE;

unsigned long GRFFTH_DE_buffer_SIZE;
char *GRFFTH_DE_buffer_POINTER;
      FILE *fp_in1, *fp_in2, *fp_outLOG;
      unsigned long size_in1, size_in2, k1, k2, LINE10len1, LINE10len2;
      char LINE10_1[257]; // 000..255, 256 = 0
      char LINE10_2[257]; // 000..255, 256 = 0
      char workbyte;
unsigned long Railgunhits;
unsigned long WILDgunhits;
#define ASIZE 256
char *FoundInPTR;
char TAGfree[6] = "*@$#%";
int PatternLEN;

#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif

#ifndef false
#define false 0
#endif
#ifndef true
#define true 1
#endif

typedef unsigned char boolean;

#define KAZE_tolower(c) ( (((c) >= 'A') && ((c) <= 'Z')) ? ((c) - 'A' + 'a') : (c) )
#define KAZE_toupper(c) ( (((c) >= 'a') && ((c) <= 'z')) ? ((c) - 'a' + 'A') : (c) )

long maskGLOBALlen; // for speed up ((12415s - 755s)/755)*100% = 1544%
long nameGLOBALlen; 

long VIVA_IgorPavlov_invocations_global_counter = 0;
long WildGLOBALhits = 0, TotalLinesENC = 0;


void * memchrKAZE (
        const void * buf,
        const void * chr,
        unsigned long cnt
        )
{
        while ( cnt && (*(unsigned char *)buf != *(unsigned char*)chr) ) {
                buf = (unsigned char *)buf + 1;
                cnt--;
        }

        return(cnt ? (void *)buf : NULL);
}
//Exit:
//       returns pointer to first occurence of chr in buf
//       returns NULL if chr not found in the first cnt bytes


long KAZE_strlen (
        const char * str
        )
{
        const char *eos = str;

        while( *eos++ ) ;

        return( (int)(eos - str - 1) );
}
//_KAZE_strlen PROC NEAR
//; Line 225: const char *eos = str;
//        mov     ecx, DWORD PTR _str$[esp-4]
//        mov     eax, ecx
//$L725:
//; Line 227: while( *eos++ ) ;
//        mov     dl, BYTE PTR [eax]
//        inc     eax
//        test    dl, dl
//        jne     SHORT $L725
//; Line 229: return( (int)(eos - str - 1) );
//        sub     eax, ecx
//        dec     eax
//; Line 230
//        ret     0
//_KAZE_strlen ENDP


long KAZE_strlenLF (
        const char * str
        )
{
        const char *eos = str;
        char LFa[1];
        LFa[0] = 10; //BUG UNcrushed yet: for Windows 13 for POSIX 10
        while( *eos++ != LFa[0] ) ;

        return( (int)(eos - str - 1) );
}


// wildcard '*' any character(s) or empty,
// wildcard '@' any character or empty,
// wildcard '#' any character and not empty,
// wildcard '$' any ALPHA character and not empty,
// wildcard '%' any NON-ALPHA character and not empty.
// Note: Due to different line endings(CRLF in Windows; LF in UNIX)
//       you must add a '@' wildcard in place of CR: for example in
//       case of searching for '*.pdf' write '*.pdf@'.
// Pattern example: *%%take@%%$$@

static boolean EnhancedMaskTest_OrEmpty_AndNotEmpty(const char *mask, int maskPos, 
                                                 const char *name, int namePos)
{
  char maskChar;
  //int maskLen = KAZE_strlen(mask) - maskPos;
  //int nameLen = KAZE_strlenLF(name) - namePos;
  // Above 2 lines are modified with GLOBAL variables for speed as follows:
  int maskLen = maskGLOBALlen - maskPos; // for speed up ((12415s - 755s)/755)*100% = 1544%
  int nameLen = nameGLOBALlen - namePos;
  if (maskLen == 0)
    if (nameLen == 0)
      return true;
    else
      return false;
  maskChar = mask[maskPos];
  if (maskChar == '@') // or empty    
  {
    /*
    if (EnhancedMaskTest_OrEmpty_AndNotEmpty(mask, maskPos + 1, name, namePos)) 
      return true;
    */
    if (EnhancedMaskTest_OrEmpty_AndNotEmpty(mask, maskPos + 1, name, namePos)) // KAZE: THIS LINE DECIDES whether 'or empty' or 'and not empty'
      return true;                                                  //       uncommented is 'or empty'
    if (nameLen == 0) 
      return false;
    return EnhancedMaskTest_OrEmpty_AndNotEmpty(mask,  maskPos + 1, name, namePos + 1);
  }
  else if(maskChar == '#') // and not empty
  {
    /*
    if (EnhancedMaskTest_OrEmpty_AndNotEmpty(mask, maskPos + 1, name, namePos)) 
      return true;
    */
    if (nameLen == 0) 
      return false;
    return EnhancedMaskTest_OrEmpty_AndNotEmpty(mask,  maskPos + 1, name, namePos + 1);
  }
  else if(maskChar == '%') // and not empty AND NOT ALPHA
  {
    /*
    if (EnhancedMaskTest_OrEmpty_AndNotEmpty(mask, maskPos + 1, name, namePos)) 
      return true;
    */

    char c = name[namePos]; 
      if ( (KAZE_toupper(c) >= 'A') && (KAZE_toupper(c) <= 'Z') ) // Stupidly slow: make it faster ...
        return false;

    if (nameLen == 0)
      return false;
    return EnhancedMaskTest_OrEmpty_AndNotEmpty(mask,  maskPos + 1, name, namePos + 1);
  }
  else if(maskChar == '$') // and not empty AND ALPHA
  {
    /*
    if (EnhancedMaskTest_OrEmpty_AndNotEmpty(mask, maskPos + 1, name, namePos)) 
      return true;
    */

    char c = name[namePos]; 
      if ( (KAZE_toupper(c) < 'A') || (KAZE_toupper(c) > 'Z') ) // Stupidly slow: make it faster ...
        return false;

    if (nameLen == 0)
      return false;
    return EnhancedMaskTest_OrEmpty_AndNotEmpty(mask,  maskPos + 1, name, namePos + 1);
  }
  else if(maskChar == '*')
  {
    if (EnhancedMaskTest_OrEmpty_AndNotEmpty(mask, maskPos + 1, name, namePos))
      return true;
    if (nameLen == 0) 
      return false;
    return EnhancedMaskTest_OrEmpty_AndNotEmpty(mask, maskPos, name, namePos + 1);
  }
  else
  {
    char c = name[namePos];
    //if (maskChar != c)
      if (KAZE_toupper(maskChar) != KAZE_toupper(c))
        return false;
    return EnhancedMaskTest_OrEmpty_AndNotEmpty(mask,  maskPos + 1, name, namePos + 1);
  }
}


boolean CompareWildCardWithName(const char *mask, const char *name)
{
  boolean Txpbool;
  VIVA_IgorPavlov_invocations_global_counter++;

  maskGLOBALlen = KAZE_strlen(mask);
  nameGLOBALlen = KAZE_strlenLF(name);

  Txpbool = EnhancedMaskTest_OrEmpty_AndNotEmpty(mask, 0, name, 0);
  if (Txpbool) WildGLOBALhits++;
  return Txpbool;
}
// Above fragment(modified) is from wildcard.cpp from 7zip package.


unsigned long Blunderbuss(char *y, char *x, long n, int m)
   {
int Cycle;
unsigned long hits = 0;
long ThunderwithL = 0, ThunderwithR = 0;
int OneFailureCanRuinYou;

    if ( n == 0 ) return(0);
    for (;;) {

  //Search area is between y[0] .. y[n-1]
    while (y[ThunderwithR] != 10) {++ThunderwithR;} // Works both on UNIX(LF) and Windows(CRLF)
    while (ThunderwithL != 0 && y[--ThunderwithL] != 10) {}
    if (ThunderwithL != 0) ThunderwithL++;
    TotalLinesENC++;

 // To avoid nasty big delays(hours sometime) length of searched line must be limited:
 // recursive function is very heavy then!
 // Something like LBL960 in memory.

OneFailureCanRuinYou = 0; // Presumption for flushing.

 if (ThunderwithR - ThunderwithL <= 960) {
                                         }
                                         else
 OneFailureCanRuinYou = 1; // Presumption for NOT flushing.

if (OneFailureCanRuinYou == 0)
{
          if ( CompareWildCardWithName ( x, &y[ThunderwithL] ) )
          { //if ( memchrKAZE(&y[ThunderwithL], &TAGfree[0], ThunderwithR - ThunderwithL) == NULL && memchrKAZE(&y[ThunderwithL], &TAGfree[1], ThunderwithR - ThunderwithL) == NULL )
            { hits++; 
              /*
              for( Cycle = 0; Cycle < ThunderwithR - ThunderwithL + 1; Cycle++ )
              putchar( y[ThunderwithL + Cycle]);
              */
              //putchar( '\n');
              fwrite( &y[ThunderwithL], ThunderwithR - ThunderwithL + 1, 1, fp_outLOG );
            }
          } // Wildcard if
}
    ThunderwithL = ++ThunderwithR;
    if ( ThunderwithR >= n - 1 ) return(hits);

    } // for (;;)
   }

// Kaze ]

// Kaze [

// ### Mix(2in1) of Karp-Rabin & Boyer-Moore-Horspool algorithm [
// Caution: For better speed the case 'if (cbPattern==1)' was removed, so Pattern must be longer than 1 char.
char * Railgun (char * pbTarget,
     char * pbPattern,
     unsigned long cbTarget,
     unsigned long cbPattern)
{
    char *  pbTargetMax = pbTarget + cbTarget;
    register unsigned long  ulHashPattern;
    unsigned long  ulHashTarget;
    unsigned long  count;
    unsigned long  countSTATIC, countRemainder;

    long i; //BMH needed
    int a, j, bm_bc[ASIZE]; //BMH needed
    unsigned char ch; //BMH needed
//    unsigned char lastch, firstch; //BMH needed

    if (cbPattern > cbTarget)
        return(NULL);

        countSTATIC = cbPattern-2;

// Doesn't work when cbPattern = 1
if (cbTarget<961) // This value is arbitrary(don't know how exactly), it ensures(at least must) better performance than 'Boyer_Moore_Horspool'.
{
        pbTarget = pbTarget+cbPattern;
        ulHashPattern = ( (*(char *)(pbPattern))<<8 ) + *(pbPattern+(cbPattern-1));

    for ( ;; )
    {
        // The line below gives for 'cbPattern'>=1:
        // Karp_Rabin_Kaze_4_OCTETS_hits/Karp_Rabin_Kaze_4_OCTETS_clocks: 4/543
        // Karp_Rabin_Kaze_4_OCTETS performance: 372KB/clock
/*
        if ( (ulHashPattern == ( (*(char *)(pbTarget-cbPattern))<<8 ) + *(pbTarget-1)) && !memcmp(pbPattern, pbTarget-cbPattern, (unsigned int)cbPattern) )
            return((long)(pbTarget-cbPattern));
*/

        // The fragment below gives for 'cbPattern'>=2:
        // Karp_Rabin_Kaze_4_OCTETS_hits/Karp_Rabin_Kaze_4_OCTETS_clocks: 4/546
        // Karp_Rabin_Kaze_4_OCTETS performance: 370KB/clock

        if ( ulHashPattern == ( (*(char *)(pbTarget-cbPattern))<<8 ) + *(pbTarget-1) ) {
         count = countSTATIC;
         while ( count && *(char *)(pbPattern+1+(countSTATIC-count)) == *(char *)(pbTarget-cbPattern+1+(countSTATIC-count)) ) {
               count--;
         }
         if ( count == 0) return((pbTarget-cbPattern));
        }

        // The fragment below gives for 'cbPattern'>=2:
	// Karp_Rabin_Kaze_4_OCTETS_hits/Karp_Rabin_Kaze_4_OCTETS_clocks: 4/554
	// Karp_Rabin_Kaze_4_OCTETS performance: 364KB/clock
/*
        if ( ulHashPattern == ( (*(char *)(pbTarget-cbPattern))<<8 ) + *(pbTarget-1) ) {
         count = countSTATIC>>2;
         countRemainder = countSTATIC % 4;

         while ( count && *(unsigned long *)(pbPattern+1+((count-1)<<2)) == *(unsigned long *)(pbTarget-cbPattern+1+((count-1)<<2)) ) {
               count--;
         }
	 //if (count == 0) {  // Disastrous degradation only from this line(317KB/clock when 1+2x4+2+1 bytes pattern: 'skillessness'; 312KB/clock when 1+1x4+2+1 bytes pattern: 'underdog'), otherwise 368KB/clock.
         while ( countRemainder && *(char *)(pbPattern+1+(countSTATIC-countRemainder)) == *(char *)(pbTarget-cbPattern+1+(countSTATIC-countRemainder)) ) {
               countRemainder--;
         }
         //if ( countRemainder == 0) return((long)(pbTarget-cbPattern));
         if ( count+countRemainder == 0) return((long)(pbTarget-cbPattern));
         //}
        }
*/

        pbTarget++;
        if (pbTarget > pbTargetMax)
            return(NULL);
    }
}
else
{
    /* Preprocessing */
    for (a=0; a < ASIZE; a++) bm_bc[a]=cbPattern;
    for (j=0; j < cbPattern-1; j++) bm_bc[pbPattern[j]]=cbPattern-j-1;

    /* Searching */
    //lastch=pbPattern[cbPattern-1];
    //firstch=pbPattern[0];
    i=0;
    while (i <= cbTarget-cbPattern) {
       ch=pbTarget[i+cbPattern-1];
       //if (ch ==lastch)
          //if (memcmp(&pbTarget[i],pbPattern,cbPattern-1) == 0) OUTPUT(i);
          //if (ch == lastch && pbTarget[i] == firstch && memcmp(&pbTarget[i],pbPattern,cbPattern-1) == 0) return(i);  // Kaze: The idea(to prevent execution of slower 'memcmp') is borrowed from Karp-Rabin i.e. to perform a slower check only when the target "looks like".
          if (ch == pbPattern[cbPattern-1] && pbTarget[i] == pbPattern[0])
             {
         count = countSTATIC;
         while ( count && *(char *)(pbPattern+1+(countSTATIC-count)) == *(char *)(&pbTarget[i]+1+(countSTATIC-count)) ) {
               count--;
         }
         if ( count == 0) return(pbTarget+i);
	     }
       i+=bm_bc[ch];
    }
    return(NULL);
}
}
// ### Mix(2in1) of Karp-Rabin & Boyer-Moore-Horspool algorithm ]


// ### Railgun_totalhits [
char * Railgun_totalhits (char * pbTarget,
     char * pbPattern,
     unsigned long cbTarget,
     unsigned long cbPattern)
{
    char *  pbTargetMax = pbTarget + cbTarget;
    register unsigned long  ulHashPattern;
    unsigned long  ulHashTarget;
    unsigned long  count;
    unsigned long  countSTATIC, countRemainder;

    long i; //BMH needed
    int a, j, bm_bc[ASIZE]; //BMH needed
    unsigned char ch; //BMH needed
//    unsigned char lastch, firstch; //BMH needed

    if (cbPattern > cbTarget)
        return(NULL);

        countSTATIC = cbPattern-2;

// Doesn't work when cbPattern = 1
if (cbTarget<961) // This value is arbitrary(don't know how exactly), it ensures(at least must) better performance than 'Boyer_Moore_Horspool'.
{
        pbTarget = pbTarget+cbPattern;
        ulHashPattern = ( (*(char *)(pbPattern))<<8 ) + *(pbPattern+(cbPattern-1));

    for ( ;; )
    {
        // The line below gives for 'cbPattern'>=1:
        // Karp_Rabin_Kaze_4_OCTETS_hits/Karp_Rabin_Kaze_4_OCTETS_clocks: 4/543
        // Karp_Rabin_Kaze_4_OCTETS performance: 372KB/clock
/*
        if ( (ulHashPattern == ( (*(char *)(pbTarget-cbPattern))<<8 ) + *(pbTarget-1)) && !memcmp(pbPattern, pbTarget-cbPattern, (unsigned int)cbPattern) )
            return((long)(pbTarget-cbPattern));
*/

        // The fragment below gives for 'cbPattern'>=2:
        // Karp_Rabin_Kaze_4_OCTETS_hits/Karp_Rabin_Kaze_4_OCTETS_clocks: 4/546
        // Karp_Rabin_Kaze_4_OCTETS performance: 370KB/clock

        if ( ulHashPattern == ( (*(char *)(pbTarget-cbPattern))<<8 ) + *(pbTarget-1) ) {
         count = countSTATIC;
         while ( count && *(char *)(pbPattern+1+(countSTATIC-count)) == *(char *)(pbTarget-cbPattern+1+(countSTATIC-count)) ) {
               count--;
         }
         if ( count == 0) Railgunhits++; //return((pbTarget-cbPattern));
        }

        // The fragment below gives for 'cbPattern'>=2:
	// Karp_Rabin_Kaze_4_OCTETS_hits/Karp_Rabin_Kaze_4_OCTETS_clocks: 4/554
	// Karp_Rabin_Kaze_4_OCTETS performance: 364KB/clock
/*
        if ( ulHashPattern == ( (*(char *)(pbTarget-cbPattern))<<8 ) + *(pbTarget-1) ) {
         count = countSTATIC>>2;
         countRemainder = countSTATIC % 4;

         while ( count && *(unsigned long *)(pbPattern+1+((count-1)<<2)) == *(unsigned long *)(pbTarget-cbPattern+1+((count-1)<<2)) ) {
               count--;
         }
	 //if (count == 0) {  // Disastrous degradation only from this line(317KB/clock when 1+2x4+2+1 bytes pattern: 'skillessness'; 312KB/clock when 1+1x4+2+1 bytes pattern: 'underdog'), otherwise 368KB/clock.
         while ( countRemainder && *(char *)(pbPattern+1+(countSTATIC-countRemainder)) == *(char *)(pbTarget-cbPattern+1+(countSTATIC-countRemainder)) ) {
               countRemainder--;
         }
         //if ( countRemainder == 0) return((long)(pbTarget-cbPattern));
         if ( count+countRemainder == 0) return((long)(pbTarget-cbPattern));
         //}
        }
*/

        pbTarget++;
        if (pbTarget > pbTargetMax)
            return(NULL);
    }
}
else
{
    /* Preprocessing */
    for (a=0; a < ASIZE; a++) bm_bc[a]=cbPattern;
    for (j=0; j < cbPattern-1; j++) bm_bc[pbPattern[j]]=cbPattern-j-1;

    /* Searching */
    //lastch=pbPattern[cbPattern-1];
    //firstch=pbPattern[0];
    i=0;
    while (i <= cbTarget-cbPattern) {
       ch=pbTarget[i+cbPattern-1];
       //if (ch ==lastch)
          //if (memcmp(&pbTarget[i],pbPattern,cbPattern-1) == 0) OUTPUT(i);
          //if (ch == lastch && pbTarget[i] == firstch && memcmp(&pbTarget[i],pbPattern,cbPattern-1) == 0) return(i);  // Kaze: The idea(to prevent execution of slower 'memcmp') is borrowed from Karp-Rabin i.e. to perform a slower check only when the target "looks like".
          if (ch == pbPattern[cbPattern-1] && pbTarget[i] == pbPattern[0])
             {
         count = countSTATIC;
         while ( count && *(char *)(pbPattern+1+(countSTATIC-count)) == *(char *)(&pbTarget[i]+1+(countSTATIC-count)) ) {
               count--;
         }
         if ( count == 0) Railgunhits++; //return(pbTarget+i);
	     }
       i+=bm_bc[ch];
    }
    return(NULL);
}
}
// ### Railgun_totalhits ]

// Kaze ]

void ShowUsage(void)
{
    fprintf(stdout, "Usage: Kazuya <e|E|d|D|_> inputfile outputfile\n\n");
    fprintf(stdout, "Options:\n");
    fprintf(stdout, "   E encodes without writing i.e. test-encode\n");
    fprintf(stdout, "   D decodes without writing i.e. test-decode\n");
    fprintf(stdout, "   _ decodes without writing plus searching, MaxSizeOfDecodedBuffer = %luMB\n\n", (GRFFTH_DE_buffer_MAXSIZE>>20) );
    fprintf(stdout, "Note1: Kazuya,ini: each line represents a pattern\n");
    fprintf(stdout, "       Kazuya,lst: each line represents a QuickLZ file\n");
    fprintf(stdout, "       Kazuya,log: each line is a Blunderbuss(wildcard function) hit\n");
    fprintf(stdout, "Note2: If pattern contains at least one wildcard then Blunderbuss is evoked for\n");
    fprintf(stdout, "       each line in the file, otherwise Railgun is evoked for the entire file.\n");
    fprintf(stdout, "Note3: Five wildcards are available:\n");
    fprintf(stdout, "       wildcard '*' any character(s) or empty,\n");
    fprintf(stdout, "       wildcard '@' any character or empty,\n");
    fprintf(stdout, "       wildcard '#' any character and not empty,\n");
    fprintf(stdout, "       wildcard '$' any ALPHA character and not empty,\n");
    fprintf(stdout, "       wildcard '%%' any NON-ALPHA character and not empty.\n");
    fprintf(stdout, "Note4: Due to different line endings(CRLF in Windows; LF in UNIX)\n");
    fprintf(stdout, "       you must add a '@' wildcard in place of CR:\n");
    fprintf(stdout, "       for example in case of searching for '*.pdf' write '*.pdf@'.\n");
    fprintf(stdout, "Note5: A pseudo bug exists uncrushed - End-Of-File must be LF character.\n\n");
    fprintf(stdout, "Example1: Kazuya e Caterpillar.47.RAFT6.txt Caterpillar.47.RAFT6.txt.QuickLZ\n");
    fprintf(stdout, "Example2: Kazuya d Caterpillar.47.RAFT6.txt.QuickLZ Caterpillar.47.RAFT6.txt\n");
    fprintf(stdout, "Example3: Kazuya _\n");

    exit(0);
}

    //Kazuya [
    FILE *ifile, *ofile;
    char *src, *dst, *scratch;
    size_t len, in_len; 
    //Kazuya ]

int main(int argc, char * argv[])
{
    fprintf(stdout, "Kazuya, Text decompressor-finder-dumper, revision 18, written by Kaze,\n");
    fprintf(stdout, "powered by Lasse Reinhold's excellent QuickLZ 1.4.1 library.\n\n");

    Kazuya_DE_buffer_MAXSIZE = 2 * GRFFTH_DE_buffer_MAXSIZE + 400 + 1; // 2*384MB
    //Kazuya [
    // QLZ_SCRATCH_DECOMPRESS is defined in the beginning of the quicklz.h file
    scratch = (char*) malloc(QLZ_SCRATCH_DECOMPRESS);
    //Kazuya ]

    if ( argc < 2 ) { ShowUsage(); } else
    switch (*argv[1])
    {
        case 'e' : case 'E' :
{
    if ( (argc != 4) ) { ShowUsage(); }
if( ( ifile = fopen(argv[2], "rb") ) == NULL )
{ printf( "Kazuya: Can't open %s file.\n", argv[2] ); return( 1 ); }
    if ( (*argv[1] == 'e') )
    ofile = fopen(argv[3], "wb");

    // allocate source buffer and read file
    fseek(ifile, 0, SEEK_END);
    len = ftell(ifile);
    fseek(ifile, 0, SEEK_SET);
    src = (char*) malloc(len);
    fread(src, 1, len, ifile);

    // allocate "uncompressed size" + 400 for the destination buffer
    dst = (char*) malloc(len + 400);

    // QLZ_SCRATCH_COMPRESS is defined in the beginning of the quicklz.h file
    scratch = (char*) malloc(QLZ_SCRATCH_COMPRESS);

    // compress and write result
        printf("QuickLZ: compressed %lu bytes into ",
            (unsigned long) len );
    len = qlz_compress(src, dst, len, scratch);
        printf("%lu bytes.\n",
            (unsigned long) len );
    if ( (*argv[1] == 'e') )
    fwrite(dst, len, 1, ofile);

    fclose(ifile);
    if ( (*argv[1] == 'e') )
    fclose(ofile);
break;
}
        case 'd' : case 'D' :
{
    if ( (argc != 4) ) { ShowUsage(); }
if( ( ifile = fopen(argv[2], "rb") ) == NULL )
{ printf( "Kazuya: Can't open %s file.\n", argv[2] ); return( 1 ); }
   if ( (*argv[1] == 'd') )
   ofile = fopen(argv[3], "wb");

   // allocate source buffer
   fseek(ifile, 0, SEEK_END);
   len = ftell(ifile);
   fseek(ifile, 0, SEEK_SET);
   src = (char*) malloc(len);

   // read file and allocate destination buffer
   fread(src, 1, len, ifile);

   in_len = len;
   len = qlz_size_decompressed(src);
   dst = (char*) malloc(len);

//    // QLZ_SCRATCH_DECOMPRESS is defined in the beginning of the quicklz.h file
//    scratch = (char*) malloc(QLZ_SCRATCH_DECOMPRESS);

   // decompress and write result
        printf("QuickLZ: decompressed %lu bytes back into ",
            (unsigned long) in_len );
   len = qlz_decompress(src, dst, scratch);
        printf("%lu bytes.\n",
            (unsigned long) len );
   if ( (*argv[1] == 'd') )
   fwrite(dst, len, 1, ofile);

   fclose(ifile);
   if ( (*argv[1] == 'd') )
   fclose(ofile);
break;
}
        case '_' :
{
    if ( argc != 2 ) { ShowUsage(); } else
// Kazuya INIT [
if( ( fp_in1 = fopen( "Kazuya.lst", "rb" ) ) == NULL )
{ printf( "Kazuya: Can't open file Kazuya.lst.\n" ); return( 1 ); }
fseek( fp_in1, 0L, SEEK_END );
size_in1 = ftell( fp_in1 );
fseek( fp_in1, 0L, SEEK_SET );
printf( "Size of Kazuya.lst: %lu\n", size_in1 );

if( ( fp_in2 = fopen( "Kazuya.ini", "rb" ) ) == NULL )
{ printf( "Kazuya: Can't open file Kazuya.ini.\n" ); return( 1 ); }
fseek( fp_in2, 0L, SEEK_END );
size_in2 = ftell( fp_in2 );
fseek( fp_in2, 0L, SEEK_SET );
printf( "Size of Kazuya.ini: %lu\n", size_in2 );

if( ( fp_outLOG = fopen( "Kazuya.log", "wb" ) ) == NULL )
{ printf( "Kazuya: Can't open file Kazuya.log.\n" ); return( 1 ); }

printf( "Allocating memory %lu MB ... ", (Kazuya_DE_buffer_MAXSIZE>>20)+0); 
GRFFTH_DE_buffer_POINTER = (char *)malloc( Kazuya_DE_buffer_MAXSIZE );
if( GRFFTH_DE_buffer_POINTER == NULL )
{ puts( "\nKazuya: Needed memory allocation denied!\n" ); return( 1 ); }
printf( "OK\n" );
// Kazuya INIT ]

// MAIN CYCLE =============================================================================================================[
        for( k1 = 0; k1 < size_in1; k1++ )
	{
                fread( &workbyte, 1, 1, fp_in1 );
                if( workbyte != 10 )
                { if( workbyte != 13 ) // NON UNIX
                  { if( LINE10len1 < 255 ) { LINE10_1[ LINE10len1 ] = workbyte; }
                    LINE10len1++;
                  }
                  else
                  {
                  }
		}
		else
                { if( 1 <= LINE10len1 && LINE10len1 <= 255 )
                  { LINE10_1[ LINE10len1 ] = 0;
printf( "Decompressing '%s' ...\n", LINE10_1 );
argv[2] = LINE10_1;
// Decompression [

if( ( ifile = fopen(argv[2], "rb") ) == NULL )
{ printf( "Kazuya: Can't open %s file.\n", argv[2] ); return( 1 ); }

   fseek(ifile, 0, SEEK_END);
   len = ftell(ifile);
   fseek(ifile, 0, SEEK_SET);

if (len > GRFFTH_DE_buffer_MAXSIZE)
{ printf( "Kazuya: Decoded file exceeds %lu bytes.\n", GRFFTH_DE_buffer_MAXSIZE ); exit( 1 ); }

   // read file and allocate destination buffer
   fread(GRFFTH_DE_buffer_POINTER + GRFFTH_DE_buffer_MAXSIZE, 1, len, ifile);
   len = qlz_size_decompressed(GRFFTH_DE_buffer_POINTER + GRFFTH_DE_buffer_MAXSIZE);
   //dst = (char*) malloc(len);

if (len > GRFFTH_DE_buffer_MAXSIZE)
{ printf( "Kazuya: Decoded file exceeds %lu bytes.\n", GRFFTH_DE_buffer_MAXSIZE ); exit( 1 ); }

   GRFFTH_DE_buffer_SIZE = qlz_decompress(GRFFTH_DE_buffer_POINTER + GRFFTH_DE_buffer_MAXSIZE, GRFFTH_DE_buffer_POINTER, scratch);
   fclose(ifile);

// Decompression ]

// Kazuya SEARCH [
LINE10len2 = 0;
fseek( fp_in2, 0L, SEEK_SET );
// SUB-MAIN CYCLE =========================================================================================================[
        for( k2 = 0; k2 < size_in2; k2++ )
	{
                fread( &workbyte, 1, 1, fp_in2 );
                if( workbyte != 10 )
                { if( workbyte != 13 ) // NON UNIX
                  { if( LINE10len2 < 255 ) { LINE10_2[ LINE10len2 ] = workbyte; }
                    LINE10len2++;
                  }
                  else
                  {
                  }
		}
		else
                { if( 1 <= LINE10len2 && LINE10len2 <= 255 )
                  { LINE10_2[ LINE10len2 ] = 0;

// The presence of a wildcard decides type of searching:
PatternLEN = KAZE_strlen(LINE10_2);
if ( memchrKAZE(LINE10_2, &TAGfree[0], PatternLEN) == NULL && \
     memchrKAZE(LINE10_2, &TAGfree[1], PatternLEN) == NULL && \
     memchrKAZE(LINE10_2, &TAGfree[2], PatternLEN) == NULL && \
     memchrKAZE(LINE10_2, &TAGfree[3], PatternLEN) == NULL && \
     memchrKAZE(LINE10_2, &TAGfree[4], PatternLEN) == NULL )
{
printf( "Entire-file-searching with Railgun for '%s' ...\n", LINE10_2 );
Railgunhits=0;
// Bastumante do not forget the need for strlen(LINE10_2)>1:
FoundInPTR = Railgun_totalhits(GRFFTH_DE_buffer_POINTER, LINE10_2, GRFFTH_DE_buffer_SIZE, PatternLEN);
printf( "Railgun_totalhits: %lu\n", Railgunhits);
} else
{
printf( "Single-line-searching with Blunderbuss for '%s' ...\n", LINE10_2 );
WILDgunhits = 0;
//Blunderbuss: Alteration of Dutch donderbus: donder, thunder + bus, gun.
WILDgunhits = Blunderbuss(GRFFTH_DE_buffer_POINTER, LINE10_2, GRFFTH_DE_buffer_SIZE, PatternLEN);
printf( "Blunderbuss_totalhits: %lu\n", WILDgunhits);
}

        LINE10len2 = 0;
LINE10_2[ LINE10len2 ] = 0;
                  }
                }
        } // k2 'for'
// SUB-MAIN CYCLE =========================================================================================================]
// Kazuya SEARCH ]

        LINE10len1 = 0;
LINE10_1[ LINE10len1 ] = 0;
                  }
                }
        } // k1 'for'
// MAIN CYCLE =============================================================================================================]
printf( "\nKazuya: Total Blunderbuss(wildcard) hits: %lu\n", WildGLOBALhits);
printf( "Kazuya: Done.\n");
break;
}
        default  : ShowUsage();
    }

    return 0;
}
